//+------------------------------------------------------------------+
//|                                       NT Value Chart Recoded.mq4 |
//|                      Copyright 2013, William Kreider (Madhatt30) |
//|                                        http://www.metaquotes.net |
//|                                        correction made by mladen |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, William Kreider (Madhatt30)"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_levelcolor SteelBlue
#property indicator_levelstyle 0
#property indicator_buffers 4
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_level1 12.0
#property indicator_level2 10.0
#property indicator_level3 8.0
#property indicator_level4 6
#property indicator_level5 -6
#property indicator_level6 -8.0
#property indicator_level7 -10.0
#property indicator_level8 -12
#property indicator_maximum 15
#property indicator_minimum -15
//--- input parameters
extern int       NumBars=5;
extern color     Bullish_Color=LimeGreen;
extern color     Bearish_Color=Red;
extern color     Actual_Color=Yellow;

extern string    Note0="**** VC Bar Width ****";
extern int       Wick=2;
extern int       Body=6;

extern string    Note1="**** OB/OS Levels ****";
extern int       OBHigh_Upper=12;
extern int       OBHigh_Lower=8;
extern int       OSLow_Upper=-8;
extern int       OSLow_Lower=-12;

extern string    Note2="**** OB/OS Level Colors ****";
extern color     OBHigh_Color=C'255,164,177';
extern color     Normal_Color=C'5,116,5';
extern color     OSLow_Color=C'255,164,177';

extern string    Note3="**** Alert Settings ****";
extern bool      useAlerts=false;
extern int       NumLevels=4;
extern int       level1=10;
extern int       level2=-10;
extern int       level3=11;
extern int       level4=-11;
extern int       level5=10;
extern int       level6=-10;
extern double    exitSig = 0.5;
extern int       BarsToDraw=500;
extern string    UniqueID = "ValueChart1";

double levels[6];
bool in[6];

double VOpen[], VHigh[], VLow[], VClose[], Typical;

/*
The formula of the indicator is:
OPEN = (OPEN - MVA(TYPICAL)) / (ATR / ATR_N)
HIGH = (HIGH - MVA(TYPICAL)) / (ATR / ATR_N)
LOW = (LOW - MVA(TYPICAL)) / (ATR / ATR_N)
CLOSE = (CLOSE - MVA(TYPICAL)) / (ATR / ATR_N)
TYPICAL = (HIGH + LOW + CLOSE) / 3
MVA is Market Value Added
*/
string shortname;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_NONE);
   SetIndexBuffer(0, VHigh);
   SetIndexStyle(1, DRAW_NONE);
   SetIndexBuffer(1, VLow);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexBuffer(2, VOpen);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexBuffer(3, VClose);
   shortname=UniqueID+"- Value Chart Deluxe Edition";
   IndicatorShortName(shortname);
   
   levels[0] = level1;
   levels[1] = level2;
   levels[2] = level3;
   levels[3] = level4;
   levels[4] = level5;
   levels[5] = level6;
   
   for (int i = 0; i < NumLevels; i++)
   {
      in[i] = true;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   string lookFor       = UniqueID+"VC_";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   ObjectDelete(UniqueID+"TopRec1");
   ObjectDelete(UniqueID+"MidRec1");
   ObjectDelete(UniqueID+"BotRec2");
   return(0); 
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(), curBar, window, cnt;
   string Wicks, Bodies;
   double relativeClose;
   window=WindowFind(shortname);
//----
   for(int i = 0; i<=MathMin(Bars-1,BarsToDraw); i++){
//      MVACall=MVA(NumBars,i);
//      ATRCall=ATR(NumBars,i);
//      VOpen[i]    = (Open[i] - (MVACall / ATRCall));
//      MVACall=MVA(NumBars,i);
//      ATRCall=ATR(NumBars,i);
//      VHigh[i]    = (High[i] - (MVACall / ATRCall));
//      MVACall=MVA(NumBars,i);
//      ATRCall=ATR(NumBars,i);
//      VLow[i]     = (Low[i] - (MVACall / ATRCall));
//      MVACall=MVA(NumBars,i);
//      ATRCall=ATR(NumBars,i);
//      VClose[i]   = (Close[i] - (MVACall / ATRCall));
      
      VOpen[i]    = (Open[i] - (MVA(NumBars,i))) / (ATR(NumBars,i));
      VHigh[i]    = (High[i] - (MVA(NumBars,i))) / (ATR(NumBars,i));
      VLow[i]     = (Low[i] - (MVA(NumBars,i))) / (ATR(NumBars,i));
      VClose[i]   = (Close[i] - (MVA(NumBars,i))) / (ATR(NumBars,i));
      
      curBar=Bars-i;
      
      // ***************************** Start Colored Zones ************************************
      // Create Rectangles for top and bottom
      // Top
      int bars = MathMin(Bars-1,BarsToDraw);
      ObjectCreate(UniqueID+"TopRec1",OBJ_RECTANGLE,window, Time[bars], OBHigh_Upper, Time[0]+300, OBHigh_Lower);
      ObjectSet(UniqueID+"TopRec1",OBJPROP_COLOR,OBHigh_Color);
      ObjectSet(UniqueID+"TopRec1", OBJPROP_TIME2, Time[0]+300);
      ObjectSet(UniqueID+"TopRec1", OBJPROP_PRICE1,OBHigh_Upper);
      ObjectSet(UniqueID+"TopRec1", OBJPROP_PRICE2,OBHigh_Lower);
         
      // Mid
      ObjectCreate(UniqueID+"MidRec1",OBJ_RECTANGLE,window, Time[bars], OBHigh_Lower, Time[0]+300, OSLow_Upper);
      ObjectSet(UniqueID+"MidRec1",OBJPROP_COLOR,Normal_Color);
      ObjectSet(UniqueID+"MidRec1", OBJPROP_TIME2, Time[0]+300);
      ObjectSet(UniqueID+"MidRec1", OBJPROP_PRICE1,OBHigh_Lower);
      ObjectSet(UniqueID+"MidRec1", OBJPROP_PRICE2,OSLow_Upper);
      
      // Bottom
      ObjectCreate(UniqueID+"BotRec2",OBJ_RECTANGLE,window, Time[bars], OSLow_Lower, Time[0]+300, OSLow_Upper);
      ObjectSet(UniqueID+"BotRec2",OBJPROP_COLOR,OSLow_Color);
      ObjectSet(UniqueID+"BotRec2", OBJPROP_TIME2, Time[0]+300);
      ObjectSet(UniqueID+"BotRec2", OBJPROP_PRICE1,OSLow_Lower);
      ObjectSet(UniqueID+"BotRec2", OBJPROP_PRICE2,OSLow_Upper);
      // ****************************** End Colored Zones *************************************
      // *************************** Plot VC Bars on Chart ***************************
      Wicks=UniqueID+"VC_HL_" + curBar;
      ObjectCreate(Wicks,OBJ_TREND,window,Time[i],VHigh[i],Time[i],VLow[i]);
      ObjectSet(Wicks, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(Wicks, OBJPROP_RAY, FALSE);
      ObjectSet(Wicks, OBJPROP_WIDTH, Wick);
      ObjectSet(Wicks,OBJPROP_TIME1,Time[i]);
      ObjectSet(Wicks,OBJPROP_PRICE1,VHigh[i]);
      ObjectSet(Wicks,OBJPROP_TIME2,Time[i]);
      ObjectSet(Wicks,OBJPROP_PRICE2,VLow[i]);      
      Bodies=UniqueID+"VC_OC_" + curBar;
      ObjectCreate(Bodies,OBJ_TREND,window,Time[i],VOpen[i],Time[i],VClose[i]);
      ObjectSet(Bodies, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(Bodies, OBJPROP_RAY, FALSE);
      ObjectSet(Bodies, OBJPROP_WIDTH, Body);
      ObjectSet(Bodies,OBJPROP_TIME1,Time[i]);
      ObjectSet(Bodies,OBJPROP_PRICE1,VOpen[i]);
      ObjectSet(Bodies,OBJPROP_TIME2,Time[i]);
      ObjectSet(Bodies,OBJPROP_PRICE2,VClose[i]);   

      relativeClose=VClose[0];
      if(Open[i] <= Close[i]){
         ObjectSet(Wicks, OBJPROP_COLOR, Bullish_Color);
         ObjectSet(Bodies, OBJPROP_COLOR, Bullish_Color);
      }else{
         ObjectSet(Wicks, OBJPROP_COLOR, Bearish_Color);
         ObjectSet(Bodies, OBJPROP_COLOR, Bearish_Color);
      }
      
      // Create Price Line on VC
      ObjectCreate(UniqueID+"VC_BarPrice", OBJ_HLINE, window, 0, VClose[0]);
      ObjectSet(UniqueID+"VC_BarPrice", OBJPROP_COLOR, Actual_Color);
      ObjectSet(UniqueID+"VC_BarPrice", OBJPROP_PRICE1, relativeClose);
      
      // Begin Alerts Section
      if(useAlerts){
         for (cnt = 0; cnt < NumLevels; cnt++){
            double level = levels[cnt];
            if (level > 0){
               if (relativeClose >= level && in[cnt] == false){
                  in[cnt] = true;
                  Alert(Symbol(), " (", Period(), " min) signal: Value chart above ", level, "!");
               }
               if (relativeClose < level - exitSig && in[cnt] == true){
                  in[cnt] = false;
               }
            }
            if (level < 0){
               if (relativeClose <= level && in[cnt] == false){
                  in[cnt] = true;
                  Alert(Symbol(), " (", Period(), " min) signal: Value chart below ", level, "!");
               }     
         
               if (relativeClose > level + exitSig && in[cnt] == true){
                  in[cnt] = false;
               }  
            }
         } 
      }   
      // End Alerts Section
   }
   return(0);
  }
//----
// Market Value Added function
double MVA(int tNumBars, int CBar){
   double sum, floatingAxis;
   for(int k = CBar; k < tNumBars + CBar; k++){
      sum+=((High[k] + Low[k]) / 2.0);
   }
   floatingAxis =( sum / tNumBars);
   return(floatingAxis);
}

// Average True Range Function
double ATR(int tNumBars, int CBar){
   double sum, volitilityUnit;
   for(int k = CBar; k < tNumBars + CBar; k++){
      sum += (High[k] - Low[k]);
   }
   volitilityUnit = (0.2 * (sum / tNumBars));
   if(volitilityUnit == 0 || volitilityUnit == 0.0){
      volitilityUnit = 0.00000001;
   }
   return(volitilityUnit);
}
//+------------------------------------------------------------------+